//-----------------------------------------------------------------------------
// p[^錾
#define KEY_COLOR 1.0f

//-----------------------------------------------------------------------------
//̓GtFNgɏڂȊO͂Ȃقǂł

// @ϊs
float4x4 WorldViewProjMatrix	  : WORLDVIEWPROJECTION;
float4x4 WorldMatrix			  : WORLD;
float4x4 ViewMatrix			   : VIEW;

// }eAF
float4 MaterialDiffuse   : DIFFUSE  < string Object = "Geometry"; >;
static const float  MaterialAlpha = MaterialDiffuse.a;
float4   GroundShadowColor : GROUNDSHADOWCOLOR;

float4 EdgeColor		 : EDGECOLOR;
static const float  EdgeAlpha = EdgeColor.a;

// MMD{sampler㏑Ȃ߂̋LqłB폜sB
sampler MMDSamp0 : register(s0);
sampler MMDSamp1 : register(s1);
sampler MMDSamp2 : register(s2);

// IuWFNg̃eNX`
texture ObjectTexture: MATERIALTEXTURE;
sampler ObjTexSampler = sampler_state
{
	texture = <ObjectTexture>;
	MINFILTER = LINEAR;
	MAGFILTER = LINEAR;
};

bool use_texture;  //eNX`̗L
//bool use_toon;	 //gD[̗L

struct VS_OUTPUT
{
	float4 Pos		: POSITION;		// ˉeϊW
	float2 TexCoord	: TEXCOORD0;	// UV
	float4 Depth	: TEXCOORD1;	// _[x
};

//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
//@IuWFNg`

// _VF[_
#ifndef MIKUMIKUMOVING
VS_OUTPUT Basic_VS(float4 Pos: POSITION, float2 Tex: TEXCOORD0)
#else
VS_OUTPUT Basic_VS(MMM_SKINNING_INPUT IN)
#endif
{
	VS_OUTPUT Out = (VS_OUTPUT)0;

	//@MikuMikuMoving Ǝ̃XLjO֐(MMM_SkinnedPosition)B
	#ifdef MIKUMIKUMOVING
	float4 Pos = MMM_SkinnedPosition(IN.Pos, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1);
	float2 Tex = IN.Tex;
	#endif

	// J_̃[hr[ˉeϊ
	Out.Pos = mul( Pos, WorldViewProjMatrix );
	
	Out.Depth = Out.Pos;
	Out.TexCoord = Tex;
	
	return Out;
}

// sNZVF[_ieNX`Ȃj
float4 Basic_PS(VS_OUTPUT IN) : COLOR
{
	return float4(KEY_COLOR, KEY_COLOR, KEY_COLOR, MaterialAlpha);
}
// sNZVF[_ieNX`j
float4 Tex_PS(VS_OUTPUT IN) : COLOR
{
	return float4(KEY_COLOR, KEY_COLOR, KEY_COLOR, MaterialAlpha * tex2D(ObjTexSampler,IN.TexCoord).a);
}

// IuWFNg`iZtVhEFȂAeNX`FȂjpeNjbN
technique MainTec <
	string MMDPass = "object";
	bool UseTexture = false;
> {
	pass DrawObject
	{
		VertexShader = compile vs_2_0 Basic_VS();
		PixelShader  = compile ps_2_0 Basic_PS();
	}
}
// IuWFNg`iZtVhEFȂAeNX`FjpeNjbN
technique MainTexTec <
	string MMDPass = "object";
	bool UseTexture = true;
> {
	pass DrawObject
	{
		VertexShader = compile vs_2_0 Basic_VS();
		PixelShader  = compile ps_2_0 Tex_PS();
	}
}

// IuWFNg`iZtVhEFAeNX`FȂjpeNjbN
technique MainTecBS  <
	string MMDPass = "object_ss";
	bool UseTexture = false;
> {
	pass DrawObject {
		VertexShader = compile vs_2_0 Basic_VS();
		PixelShader  = compile ps_2_0 Basic_PS();
	}
}
// IuWFNg`iZtVhEFAeNX`FjpeNjbN
technique MainTexTecBS  <
	string MMDPass = "object_ss";
	bool UseTexture = true;
> {
	pass DrawObject {
		VertexShader = compile vs_2_0 Basic_VS();
		PixelShader  = compile ps_2_0 Tex_PS();
	}
}
//-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-
// ֊s`

// _VF[_
#ifdef MIKUMIKUMOVING
float4 ColorRender_VS(MMM_SKINNING_INPUT IN) : POSITION
#else
float4 ColorRender_VS(float4 Pos : POSITION) : POSITION
#endif
{
	//@MikuMikuMoving Ǝ̃XLjO֐(MMM_SkinnedPosition)
	#ifdef MIKUMIKUMOVING
	float4 Pos = MMM_SkinnedPosition(IN.Pos, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1);
	#endif

	// J_̃[hr[ˉeϊ
	return mul( Pos, WorldViewProjMatrix );
}

// sNZVF[_
float4 ColorRender_PS() : COLOR
{
	return float4(KEY_COLOR, KEY_COLOR, KEY_COLOR, EdgeAlpha);
}

// ֊s`peNjbN
technique EdgeTec < string MMDPass = "edge"; > {
	pass DrawEdge {
//		AlphaBlendEnable = TRUE;
		AlphaBlendEnable = FALSE;
		AlphaTestEnable  = FALSE;

		VertexShader = compile vs_2_0 ColorRender_VS();
		PixelShader  = compile ps_2_0 ColorRender_PS();
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////
// ZtVhEpZlvbg
//technique ZplotTec < string MMDPass = "zplot"; > { }

///////////////////////////////////////////////////////////////////////////////////////////////
// eiZtVhEj`

// _VF[_
#ifndef MIKUMIKUMOVING
float4 Shadow_VS(float4 Pos : POSITION) : POSITION
#else
float4 Shadow_VS(MMM_SKINNING_INPUT IN) : POSITION
#endif
{
	//================================================================================
	//MikuMikuMovingƎ̃XLjO֐(MMM_SkinnedPosition)BW擾B
	//================================================================================
	#ifdef MIKUMIKUMOVING
	float4 Pos = MMM_SkinnedPosition(IN.Pos, IN.BlendWeight, IN.BlendIndices, IN.SdefC, IN.SdefR0, IN.SdefR1);
	#endif

    // J_̃[hr[ˉeϊ
    return mul( Pos, WorldViewProjMatrix );
}

// sNZVF[_
float4 Shadow_PS() : COLOR
{
    // FœhԂ
    return float4(1,1,1,GroundShadowColor.a);
}

// e`peNjbN
technique ShadowTec < string MMDPass = "shadow"; > {
    pass DrawShadow {
        VertexShader = compile vs_2_0 Shadow_VS();
        PixelShader  = compile ps_2_0 Shadow_PS();
    }
}

